// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from data_tamer_msgs:msg/Schemas.idl
// generated code does not contain a copyright notice

#ifndef DATA_TAMER_MSGS__MSG__DETAIL__SCHEMAS__FUNCTIONS_H_
#define DATA_TAMER_MSGS__MSG__DETAIL__SCHEMAS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "data_tamer_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "data_tamer_msgs/msg/detail/schemas__struct.h"

/// Initialize msg/Schemas message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * data_tamer_msgs__msg__Schemas
 * )) before or use
 * data_tamer_msgs__msg__Schemas__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
bool
data_tamer_msgs__msg__Schemas__init(data_tamer_msgs__msg__Schemas * msg);

/// Finalize msg/Schemas message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
void
data_tamer_msgs__msg__Schemas__fini(data_tamer_msgs__msg__Schemas * msg);

/// Create msg/Schemas message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * data_tamer_msgs__msg__Schemas__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
data_tamer_msgs__msg__Schemas *
data_tamer_msgs__msg__Schemas__create();

/// Destroy msg/Schemas message.
/**
 * It calls
 * data_tamer_msgs__msg__Schemas__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
void
data_tamer_msgs__msg__Schemas__destroy(data_tamer_msgs__msg__Schemas * msg);

/// Check for msg/Schemas message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
bool
data_tamer_msgs__msg__Schemas__are_equal(const data_tamer_msgs__msg__Schemas * lhs, const data_tamer_msgs__msg__Schemas * rhs);

/// Copy a msg/Schemas message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
bool
data_tamer_msgs__msg__Schemas__copy(
  const data_tamer_msgs__msg__Schemas * input,
  data_tamer_msgs__msg__Schemas * output);

/// Initialize array of msg/Schemas messages.
/**
 * It allocates the memory for the number of elements and calls
 * data_tamer_msgs__msg__Schemas__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
bool
data_tamer_msgs__msg__Schemas__Sequence__init(data_tamer_msgs__msg__Schemas__Sequence * array, size_t size);

/// Finalize array of msg/Schemas messages.
/**
 * It calls
 * data_tamer_msgs__msg__Schemas__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
void
data_tamer_msgs__msg__Schemas__Sequence__fini(data_tamer_msgs__msg__Schemas__Sequence * array);

/// Create array of msg/Schemas messages.
/**
 * It allocates the memory for the array and calls
 * data_tamer_msgs__msg__Schemas__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
data_tamer_msgs__msg__Schemas__Sequence *
data_tamer_msgs__msg__Schemas__Sequence__create(size_t size);

/// Destroy array of msg/Schemas messages.
/**
 * It calls
 * data_tamer_msgs__msg__Schemas__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
void
data_tamer_msgs__msg__Schemas__Sequence__destroy(data_tamer_msgs__msg__Schemas__Sequence * array);

/// Check for msg/Schemas message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
bool
data_tamer_msgs__msg__Schemas__Sequence__are_equal(const data_tamer_msgs__msg__Schemas__Sequence * lhs, const data_tamer_msgs__msg__Schemas__Sequence * rhs);

/// Copy an array of msg/Schemas messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_data_tamer_msgs
bool
data_tamer_msgs__msg__Schemas__Sequence__copy(
  const data_tamer_msgs__msg__Schemas__Sequence * input,
  data_tamer_msgs__msg__Schemas__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // DATA_TAMER_MSGS__MSG__DETAIL__SCHEMAS__FUNCTIONS_H_
