// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from data_tamer_msgs:msg/Snapshot.idl
// generated code does not contain a copyright notice

#ifndef DATA_TAMER_MSGS__MSG__DETAIL__SNAPSHOT__TRAITS_HPP_
#define DATA_TAMER_MSGS__MSG__DETAIL__SNAPSHOT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "data_tamer_msgs/msg/detail/snapshot__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace data_tamer_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Snapshot & msg,
  std::ostream & out)
{
  out << "{";
  // member: timestamp_nsec
  {
    out << "timestamp_nsec: ";
    rosidl_generator_traits::value_to_yaml(msg.timestamp_nsec, out);
    out << ", ";
  }

  // member: schema_hash
  {
    out << "schema_hash: ";
    rosidl_generator_traits::value_to_yaml(msg.schema_hash, out);
    out << ", ";
  }

  // member: active_mask
  {
    if (msg.active_mask.size() == 0) {
      out << "active_mask: []";
    } else {
      out << "active_mask: [";
      size_t pending_items = msg.active_mask.size();
      for (auto item : msg.active_mask) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: payload
  {
    if (msg.payload.size() == 0) {
      out << "payload: []";
    } else {
      out << "payload: [";
      size_t pending_items = msg.payload.size();
      for (auto item : msg.payload) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Snapshot & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timestamp_nsec
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp_nsec: ";
    rosidl_generator_traits::value_to_yaml(msg.timestamp_nsec, out);
    out << "\n";
  }

  // member: schema_hash
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "schema_hash: ";
    rosidl_generator_traits::value_to_yaml(msg.schema_hash, out);
    out << "\n";
  }

  // member: active_mask
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.active_mask.size() == 0) {
      out << "active_mask: []\n";
    } else {
      out << "active_mask:\n";
      for (auto item : msg.active_mask) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: payload
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.payload.size() == 0) {
      out << "payload: []\n";
    } else {
      out << "payload:\n";
      for (auto item : msg.payload) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Snapshot & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace data_tamer_msgs

namespace rosidl_generator_traits
{

[[deprecated("use data_tamer_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const data_tamer_msgs::msg::Snapshot & msg,
  std::ostream & out, size_t indentation = 0)
{
  data_tamer_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use data_tamer_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const data_tamer_msgs::msg::Snapshot & msg)
{
  return data_tamer_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<data_tamer_msgs::msg::Snapshot>()
{
  return "data_tamer_msgs::msg::Snapshot";
}

template<>
inline const char * name<data_tamer_msgs::msg::Snapshot>()
{
  return "data_tamer_msgs/msg/Snapshot";
}

template<>
struct has_fixed_size<data_tamer_msgs::msg::Snapshot>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<data_tamer_msgs::msg::Snapshot>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<data_tamer_msgs::msg::Snapshot>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DATA_TAMER_MSGS__MSG__DETAIL__SNAPSHOT__TRAITS_HPP_
